from telethon import TelegramClient, events
from telegram.ext import Updater, CommandHandler, MessageHandler, Filters, CallbackQueryHandler
from telegram import InlineKeyboardButton, InlineKeyboardMarkup
import MetaTrader5 as mt5
import re
import logging
import pandas as pd
from datetime import datetime, timedelta
from dotenv import load_dotenv
import os
import json
import asyncio
import threading

# تنظیم لاگینگ
logging.basicConfig(format='%(asctime)s - %(name)s - %(levelname)s - %(message)s', level=logging.INFO)
logger = logging.getLogger(__name__)

# بارگذاری متغیرهای محیطی
load_dotenv()
API_ID = os.getenv('28211854') # درست
API_HASH = os.getenv("383ff3bd439337c51a9426cd2feffa39")  # از my.telegram.org
PHONE_NUMBER = os.getenv('+989054239573')  # شماره تلفن شما
BOT_TOKEN = os.getenv('8152744987:AAFEHZOPmxIb1o7DIT6DIXToR244RgoV3jk')  # توکن ربات از @BotFather
MT5_LOGIN = os.getenv('94125600')
MT5_PASSWORD = os.getenv('ZxFqF_2h')
MT5_SERVER = os.getenv('@1NhCyOw')
ADMIN_CHAT_ID = os.getenv('6753839683')  # چت آیدی شما

# تنظیمات پیش‌فرض
CONFIG_FILE = 'config.json'
DEFAULT_CONFIG = {
    'channels': [],  # لیست کانال‌ها
    'balance_percentage': 2.0,  # درصد بالانس برای معامله
    'leverage': 100,  # لوریج
    'use_signal_sl_tp': True,  # استفاده از SL/TP سیگنال
    'custom_sl': 50,  # حد ضرر دلخواه (پیپ)
    'custom_tp': 100,  # حد سود دلخواه (پیپ)
    'running': True  # وضعیت ربات
}

# بارگذاری یا ایجاد فایل تنظیمات
def load_config():
    if os.path.exists(CONFIG_FILE):
        with open(CONFIG_FILE, 'r') as f:
            return json.load(f)
    return DEFAULT_CONFIG

def save_config(config):
    with open(CONFIG_FILE, 'w') as f:
        json.dump(config, f, indent=4)

config = load_config()

# ایجاد کلاینت تلگرام برای اکانت شخصی
client = TelegramClient('session_name', API_ID, API_HASH)

# اتصال به MetaTrader 5
def initialize_mt5():
    if not mt5.initialize():
        logger.error("MetaTrader5 initialization failed")
        return False
    if not mt5.login(MT5_LOGIN, MT5_PASSWORD, MT5_SERVER):
        logger.error("MetaTrader5 login failed")
        return False
    logger.info("Connected to MetaTrader5")
    return True

# محاسبه حجم معامله
def calculate_lot_size(balance, percentage):
    return round((balance * percentage / 100) / 1000, 2)  # فرض: 1000 دلار به ازای هر لات

# استخراج سیگنال
def parse_signal(text):
    pattern = r'(Buy|Sell)\s*(Limit|Market)?\s*(\w+)\s*at\s*([\d.]+)\s*(?:,\s*SL:\s*([\d.]+))?\s*(?:,\s*TP:\s*([\d.]+))?'
    match = re.search(pattern, text, re.IGNORECASE)
    if match:
        return {
            'action': match.group(1).upper(),
            'order_type': match.group(2).upper() if match.group(2) else 'MARKET',
            'symbol': match.group(3),
            'entry_price': float(match.group(4)),
            'stop_loss': float(match.group(5)) if match.group(5) else None,
            'take_profit': float(match.group(6)) if match.group(6) else None
        }
    return None

# اجرای معامله
async def execute_trade(signal, bot):
    if not config['running']:
        logger.info("Robot is stopped, ignoring trade")
        return
    symbol = signal['symbol']
    if not mt5.symbol_select(symbol, True):
        logger.error(f"Symbol {symbol} not found")
        await bot.send_message(chat_id=ADMIN_CHAT_ID, text=f"❌ Symbol {symbol} not found")
        return
    balance = mt5.account_info().balance
    lot = calculate_lot_size(balance, config['balance_percentage'])
    price = signal['entry_price'] if signal['order_type'] == 'LIMIT' else mt5.symbol_info_tick(symbol).ask
    sl = signal['stop_loss'] if config['use_signal_sl_tp'] and signal['stop_loss'] else price - config['custom_sl'] * mt5.symbol_info(symbol).point if signal['action'] == 'BUY' else price + config['custom_sl'] * mt5.symbol_info(symbol).point
    tp = signal['take_profit'] if config['use_signal_sl_tp'] and signal['take_profit'] else price + config['custom_tp'] * mt5.symbol_info(symbol).point if signal['action'] == 'BUY' else price - config['custom_tp'] * mt5.symbol_info(symbol).point
    action = mt5.ORDER_TYPE_BUY if signal['action'] == 'BUY' else mt5.ORDER_TYPE_SELL
    order_type = mt5.ORDER_TYPE_BUY_LIMIT if signal['order_type'] == 'LIMIT' and signal['action'] == 'BUY' else mt5.ORDER_TYPE_SELL_LIMIT if signal['order_type'] == 'LIMIT' else action
    request = {
        "action": mt5.TRADE_ACTION_DEAL if signal['order_type'] == 'MARKET' else mt5.TRADE_ACTION_PENDING,
        "symbol": symbol,
        "volume": lot,
        "type": order_type,
        "price": price,
        "sl": sl,
        "tp": tp,
        "type_time": mt5.ORDER_TIME_GTC,
        "type_filling": mt5.ORDER_FILLING_IOC,
    }
    result = mt5.order_send(request)
    if result.retcode != mt5.TRADE_RETCODE_DONE:
        logger.error(f"Trade failed: {result.comment}")
        await bot.send_message(chat_id=ADMIN_CHAT_ID, text=f"❌ Trade failed for {symbol}: {result.comment}")
    else:
        logger.info(f"Trade executed: {signal}")
        await bot.send_message(chat_id=ADMIN_CHAT_ID, text=f"✅ Trade opened: {signal['action']} {symbol}, Lot: {lot}, Price: {price}, SL: {sl}, TP: {tp}")
    return result

# بررسی سود پوزیشن‌ها
async def monitor_positions(bot):
    while config['running']:
        positions = mt5.positions_get()
        for pos in positions:
            profit_percentage = (pos.profit / mt5.account_info().balance) * 100
            if profit_percentage >= 20:
                await bot.send_message(chat_id=ADMIN_CHAT_ID, text=f"📈 Position {pos.ticket} ({pos.symbol}) reached +{profit_percentage:.2f}% profit!")
        await asyncio.sleep(60)

# بررسی بسته شدن معاملات
async def monitor_closed_trades(bot):
    last_deals = {}
    while config['running']:
        history = mt5.history_deals_get(datetime.now() - timedelta(hours=1), datetime.now())
        for deal in history:
            if deal.ticket not in last_deals:
                if deal.profit != 0:
                    msg = f"🔒 Trade closed: Ticket {deal.ticket}, Symbol: {deal.symbol}, Profit: {deal.profit:.2f}"
                    if deal.comment.lower().find('sl') != -1:
                        msg += " (Closed by Stop Loss)"
                    elif deal.comment.lower().find('tp') != -1:
                        msg += " (Closed by Take Profit)"
                    await bot.send_message(chat_id=ADMIN_CHAT_ID, text=msg)
                last_deals[deal.ticket] = deal
        await asyncio.sleep(60)

# گزارش‌دهی
def generate_report(period):
    now = datetime.now()
    if period == 'daily':
        start = now - timedelta(days=1)
    elif period == 'weekly':
        start = now - timedelta(days=7)
    elif period == 'monthly':
        start = now - timedelta(days=30)
    else:  # yearly
        start = now - timedelta(days=365)
    history = mt5.history_deals_get(start, now)
    if not history:
        return f"No trades found for {period} report"
    df = pd.DataFrame(list(history), columns=['ticket', 'time', 'type', 'volume', 'symbol', 'price', 'sl', 'tp', 'profit', 'comment'])
    df['time'] = pd.to_datetime(df['time'], unit='s')
    total_trades = len(df)
    total_profit = df['profit'].sum()
    return f"{period.capitalize()} Report:\nTotal Trades: {total_trades}\nTotal Profit: ${total_profit:.2f}"

# مدیریت سیگنال‌ها (از اکانت شخصی)
@client.on(events.NewMessage(chats=config['channels']))
async def message_handler(event):
    if not config['running']:
        return
    message = event.message.text
    if message:
        signal = parse_signal(message)
        if signal:
            logger.info(f"Signal received: {signal}")
            await execute_trade(signal, updater.bot)
        else:
            logger.warning(f"Invalid signal format: {message}")

# دستورات (از طریق ربات تلگرامی)
def start(update, context):
    config['running'] = True
    save_config(config)
    update.message.reply_text("▶️ Robot started")

def stop(update, context):
    config['running'] = False
    save_config(config)
    update.message.reply_text("🛑 Robot stopped")

def open_positions(update, context):
    positions = mt5.positions_get()
    if not positions:
        update.message.reply_text("No open positions")
    else:
        msg = "📋 Open Positions:\n"
        for pos in positions:
            msg += f"Ticket: {pos.ticket}, Symbol: {pos.symbol}, Profit: {pos.profit:.2f}\n"
        update.message.reply_text(msg)

def set_percentage(update, context):
    try:
        percentage = float(context.args[0])
        config['balance_percentage'] = percentage
        save_config(config)
        update.message.reply_text(f"✅ Balance percentage set to {percentage}%")
    except:
        update.message.reply_text("❌ Invalid percentage. Use: /set_percentage 2.0")

def set_leverage(update, context):
    try:
        leverage = int(context.args[0])
        config['leverage'] = leverage
        save_config(config)
        update.message.reply_text(f"✅ Leverage set to {leverage}")
    except:
        update.message.reply_text("❌ Invalid leverage. Use: /set_leverage 100")

def set_sl_tp(update, context):
    try:
        sl, tp = map(int, context.args)
        config['custom_sl'] = sl
        config['custom_tp'] = tp
        config['use_signal_sl_tp'] = False
        save_config(config)
        update.message.reply_text(f"✅ Custom SL: {sl} pips, TP: {tp} pips")
    except:
        update.message.reply_text("❌ Invalid format. Use: /set_sl_tp 50 100")

def use_signal_sl_tp(update, context):
    config['use_signal_sl_tp'] = True
    save_config(config)
    update.message.reply_text("✅ Using SL/TP from signals")

def add_channel(update, context):
    try:
        channel = context.args[0]
        if channel not in config['channels']:
            config['channels'].append(channel)
            save_config(config)
            update.message.reply_text(f"✅ Channel {channel} added")
    except:
        update.message.reply_text("❌ Invalid channel. Use: /add_channel @ChannelName")

def report(update, context):
    period = context.args[0] if context.args else 'daily'
    if period in ['daily', 'weekly', 'monthly', 'yearly']:
        report_text = generate_report(period)
        update.message.reply_text(report_text)
    else:
        update.message.reply_text("❌ Invalid period. Use: /report daily|weekly|monthly|yearly")

def menu(update, context):
    keyboard = [
        [InlineKeyboardButton("Stop Robot", callback_data='stop'), InlineKeyboardButton("Start Robot", callback_data='start')],
        [InlineKeyboardButton("Open Positions", callback_data='open_positions')],
        [InlineKeyboardButton("Daily Report", callback_data='report_daily'), InlineKeyboardButton("Weekly Report", callback_data='report_weekly')],
        [InlineKeyboardButton("Monthly Report", callback_data='report_monthly'), InlineKeyboardButton("Yearly Report", callback_data='report_yearly')]
    ]
    reply_markup = InlineKeyboardMarkup(keyboard)
    update.message.reply_text("📋 Menu:", reply_markup=reply_markup)

def callback_handler(update, context):
    query = update.callback_query
    query.answer()
    data = query.data
    if data == 'stop':
        config['running'] = False
        save_config(config)
        query.message.reply_text("🛑 Robot stopped")
    elif data == 'start':
        config['running'] = True
        save_config(config)
        query.message.reply_text("▶️ Robot started")
    elif data == 'open_positions':
        positions = mt5.positions_get()
        if not positions:
            query.message.reply_text("No open positions")
        else:
            msg = "📋 Open Positions:\n"
            for pos in positions:
                msg += f"Ticket: {pos.ticket}, Symbol: {pos.symbol}, Profit: {pos.profit:.2f}\n"
            query.message.reply_text(msg)
    elif data.startswith('report_'):
        period = data.split('_')[1]
        report_text = generate_report(period)
        query.message.reply_text(report_text)

# اجرای ربات تلگرامی در کنار Telethon
def start_bot():
    global updater
    updater = Updater(BOT_TOKEN, use_context=True)
    dp = updater.dispatcher
    dp.add_handler(CommandHandler('start', start))
    dp.add_handler(CommandHandler('stop', stop))
    dp.add_handler(CommandHandler('open_positions', open_positions))
    dp.add_handler(CommandHandler('set_percentage', set_percentage))
    dp.add_handler(CommandHandler('set_leverage', set_leverage))
    dp.add_handler(CommandHandler('set_sl_tp', set_sl_tp))
    dp.add_handler(CommandHandler('use_signal_sl_tp', use_signal_sl_tp))
    dp.add_handler(CommandHandler('add_channel', add_channel))
    dp.add_handler(CommandHandler('report', report))
    dp.add_handler(CommandHandler('menu', menu))
    dp.add_handler(CallbackQueryHandler(callback_handler))
    updater.start_polling()
    updater.bot.send_message(chat_id=ADMIN_CHAT_ID, text="🤖 Robot started. Use /menu for commands.")

async def main():
    if not initialize_mt5():
        return
    await client.start(phone=PHONE_NUMBER)
    logger.info("Connected to Telegram account")
    threading.Thread(target=start_bot, daemon=True).start()
    client.loop.create_task(monitor_positions(updater.bot))
    client.loop.create_task(monitor_closed_trades(updater.bot))
    await client.run_until_disconnected()

if __name__ == '__main__':
    with client:
        client.loop.run_until_complete(main())